openapi: 3.0.0
info:
  title: API de Gestion de pedidos
  version: 1.0.0
servers:
  - url: http://localhost:8084

tags:
  - name: pedido
    description: API para pedidos

paths:

  /pedido:
    post:
      tags:
        - pedido
      summary: Guarda pedido
      operationId: guardarPedido
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GuardarPedido'
          application/xml:
            schema:
              $ref: '#/components/schemas/GuardarPedido'
      responses:
        '200':
          description: pedido guardado correctamente.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GuardarPedido'
            application/xml:
              schema:
                $ref: '#/components/schemas/GuardarPedido'
        default:
          description: pedido guardado correctamente.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GuardarPedido'
            application/xml:
              schema:
                $ref: '#/components/schemas/GuardarPedido'
    get:
      tags:
        - pedido
      summary: Obtiene catalogo de pedidos
      operationId: consultarPedido
      parameters:
        - in: query
          name: parametro
          required: false
          description: consulta pedidos por parametro
          schema:
            type: string
        - in: query
          name: parametros
          required: false
          description: consulta pedidos por parametros
          schema:
            $ref: '#/components/schemas/ObtenerPedido'
      responses:
        '200':
          description: Lista de pedidos recuperados correctamente.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ObtenerPedido'
            application/xml:
              schema:
                type: array
                xml:
                  name: ObtenerPedido
                  wrapped: true
                items:
                  $ref: '#/components/schemas/ObtenerPedido'
        default:
          description: Lista de pedidos recuperados correctamente.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ObtenerPedido'
            application/xml:
              schema:
                type: array
                xml:
                  name: ObtenerPedido
                  wrapped: true
                items:
                  $ref: '#/components/schemas/ObtenerPedido'
  /pedido/{pedidoId}:
    parameters:
      - name: pedidoId
        in: path
        required: true
        description: ID del pedido.
        schema:
          type: integer
    get:
      tags:
        - pedido
      summary: Obtener un pedido por su ID
      operationId: obtenerPedido
      responses:
        '200':
          description: Pedido recuperado correctamente.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ObtenerPedido'
            application/xml:
              schema:
                $ref: '#/components/schemas/ObtenerPedido'
        default:
          description: Pedido recuperado correctamente.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ObtenerPedido'
            application/xml:
              schema:
                $ref: '#/components/schemas/ObtenerPedido'

components:
  schemas:
    GuardarPedido:
      type: object
      properties:
        pedidoID:
          type: integer
          description: ID del pedido.
          example: 1
        ventaID:
          type: integer
          description: ID de la venta.
          example: 101
        contactoID:
          type: integer
          description: ID del contacto.
          example: 201
        operadorID:
          type: integer
          description: ID del operador.
          example: 301
        estado:
          type: string
          description: Estado del pedido.
          example: "Pendiente"
        fechaEntrega:
          type: string
          format: date
          description: fecha entrega del pedido.
          example: "2023-11-15"
        observaciones:
          type: string
          description: observaciones del pedido.
          example: "Sin observaciones"
        fechaTransaccion:
          type: string
          format: date-time
          description: fecha transaccion del pedido.
          example: "2023-11-15T12:00:00Z"

    ObtenerPedido:
      type: object
      properties:
        pedidoID:
          type: integer
          description: ID del pedido.
          example: 1
        ventaID:
          type: integer
          description: ID de la venta.
          example: 101
        contactoID:
          type: integer
          description: ID del contacto.
          example: 201
        operadorID:
          type: integer
          description: ID del operador.
          example: 301
        estado:
          type: string
          description: Estado del pedido.
          example: "En Atencion"
        fechaEntrega:
          type: string
          format: date
          description: fecha entrega del pedido.
          example: "2023-11-20"
        observaciones:
          type: string
          description: observaciones del pedido.
          example: "Urgente"
        fechaTransaccion:
          type: string
          format: date-time
          description: fecha transaccion del pedido.
          example: "2023-11-15T12:30:00Z"


